#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "v1_21.08.04";

new g_MapName[MAX_NAME_LENGTH];

public plugin_init() {
	plugin_registerinfo("Map Extend","Extend maptime for X minutes!",AM_VERSION_STRING);
	plugin_registercmd("admin_extend","extend",ACCESS_TIMELIMIT,"admin_extend <time>: extends maptime");
	plugin_registercmd("admin_vote_extend","vote_extend",ACCESS_TIMELIMIT,"admin_vote_extend <time>: starts vote to extends maptime");
	currentmap(g_MapName,MAX_NAME_LENGTH);
	return PLUGIN_CONTINUE;
}

public extend(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iTime;
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	iTime=strtonum(Data);
	if(iTime>0){
		log_command(User,Command,Data);
		extend_time(Data);
	}else{
		selfmessage("No valid entry for map extend!");
	}
	return PLUGIN_HANDLED;
}

public vote_extend(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	
	new iTime;
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	iTime=strtonum(Data);
	if(iTime>0){
		log_command(User,Command,Data);
		snprintf(Text,MAX_TEXT_LENGTH,"Extend %s for %s minutes?",g_MapName,Data);
		vote(Text,"YES","NO","NormVote",Data);
	}else{
		selfmessage("No valid entry for map vote extend!");
	}
	return PLUGIN_HANDLED;
}

public NormVote(WinningOption,HLData,VoteCount,UserCount) {
	new Text[MAX_TEXT_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iRatioCalc;
	new iRatio;
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	iRatio=getvar("admin_vote_ratio");
	iRatioCalc=iRatio*UserCount/100;
	if(WinningOption==1){
		if (VoteCount >= iRatioCalc ) {
			snprintf(Text, MAX_TEXT_LENGTH, "^"Extend %s for %s minutes?^"^n has won with %i votes!",g_MapName,Data,VoteCount);
			centersay(Text,12,100,140,255);
			say(Text);
			extend_time(Data);
			return PLUGIN_HANDLED;
		}
	}
	snprintf(Text, MAX_TEXT_LENGTH, "^"Extend %s for %s minutes?^"^n Vote failed! ^n Not enough votes for extend. (needed %i)",g_MapName,Data,iRatioCalc);
	centersay(Text,12,100,140,255);
	say(Text);
	return PLUGIN_HANDLED;
}

extend_time(Data[]){
	new Time[MAX_NUMBER_LENGTH];
	new iTimelimit;
	iTimelimit=getvar("mp_timelimit") + strtonum(Data);
	numtostr(iTimelimit,Time);
	setstrvar("mp_timelimit",Time);
}
	